#include "stdafx.h"

/* 
	All types are defined in basic_typedef
*/


int main(int argc, char* argv[])
{
	/*
		1. Point
		http://www.cgal.org/Manual/latest/doc_html/cgal_manual/Kernel_23_ref/Class_Point_2.html
	*/

	// create Point with the coordinates (0.5, 0.6)

	// now, extract the x and y values into two variables of type Number_type.

	// use the function CGAL::to_double (or .to_double function of Number_type)
	// to extract the double values of the x and y and print them

	/*
		2. Polygon 
		http://www.cgal.org/Manual/latest/doc_html/cgal_manual/Polygon_ref/Class_Polygon_2.html
	*/

	// create a polygon from the points (-0.4,0.3) (-1 , 1) (0, 2) (0.7, 0.1)

	// find the bounding box of the polygon (this is the smallest rectangle [parallel to axes]
	// that contains the polygon) by traversing the points of the polygon using vertices_begin (an iterator)

	/* 
		3. Polygon_set 
		http://www.cgal.org/Manual/latest/doc_html/cgal_manual/Boolean_set_operations_2_ref/Class_General_polygon_set_2.html
	*/
	
	// create an empty polygon set (Polygon_set)

	// create the polygons A,B,C = {(1,1), (2,2), (3,1)}, {(-1,1), (-2,2), (-3,1)}  {(-2,1.5), (2,1.5), (2,0), (-2,0)} 
	// and another polygon D = {(-1.5, 4) (1.5,4) (1.5, 0.3) (-1.5, 0.3)}

	// In order to use the polygon_set the polygons must be counter-clockwise oreinted. 
	// For every polygon A,B,C,D check that it's counter-clockwise using the "is_counterclockwise_oriented()" predicate.
	// In case it's not, use "reverse_orientation()".

	// Insert A,B,C into the polygon set using the "join" operation ("insert" can be used only if the polygons are disjoint).
	// Find the intersection of D with the polygon set using the "intersection" operation of the polygon_set.

	/*
		4. Polygon_with_holes
		http://www.cgal.org/Manual/latest/doc_html/cgal_manual/Boolean_set_operations_2_ref/Concept_GeneralPolygonWithHoles_2.html#Cross_link_anchor_1005
	*/

	// the result is represented as a collection of Polygon_with_holes.
	// extract all the Polygon_with_holes that define the polygon set and for each polygon 
	// print the vertices that define its boundary.

	/*	
		hint:
		Polygon_set ps; 
		Polygon_with_holes_container container; 
		ps.polygons_with_holes (std::back_inserter (container));
	*/ 

	return 0;
}

 